Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4652)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4653)
@@ -7265,16 +7170,10 @@
                  k = surf_usm_v(l)%k(m)
                  isurf = isurf + 1
-                 surfl(:,isurf) = (/ieast_u,k,j,i,m/)
-                 IF ( rad_angular_discretization ) THEN
-                    gridsurf(ieast_u,k,j,i) = isurf
-                 ENDIF
+                 surfl(:,isurf) = (/ieast,k,j,i/)
               ENDDO
               DO  m = surf_lsm_v(l)%start_index(j,i), surf_lsm_v(l)%end_index(j,i)
                  k = surf_lsm_v(l)%k(m)
                  isurf = isurf + 1
-                 surfl(:,isurf) = (/ieast_l,k,j,i,m/)
-                 IF ( rad_angular_discretization ) THEN
-                    gridsurf(ieast_u,k,j,i) = isurf
-                 ENDIF
+                 surfl(:,isurf) = (/ieast,k,j,i/)
               ENDDO
 
@@ -7283,16 +7182,10 @@
                  k = surf_usm_v(l)%k(m)
                  isurf = isurf + 1
-                 surfl(:,isurf) = (/iwest_u,k,j,i,m/)
-                 IF ( rad_angular_discretization ) THEN
-                    gridsurf(iwest_u,k,j,i) = isurf
-                 ENDIF
+                 surfl(:,isurf) = (/iwest,k,j,i/)
               ENDDO
               DO  m = surf_lsm_v(l)%start_index(j,i), surf_lsm_v(l)%end_index(j,i)
                  k = surf_lsm_v(l)%k(m)
                  isurf = isurf + 1
-                 surfl(:,isurf) = (/iwest_l,k,j,i,m/)
-                 IF ( rad_angular_discretization ) THEN
-                    gridsurf(iwest_u,k,j,i) = isurf
-                 ENDIF
+                 surfl(:,isurf) = (/iwest,k,j,i/)
               ENDDO
            ENDDO
@@ -7406,6 +7299,32 @@
        surf = surfl
 #endif
-
-!--
+!
+!--    Populate gridsurf with reverse global indices (->surf)
+       IF ( rad_angular_discretization )  THEN
+          DO  isurf = 1, nsurfl
+             gridsurf(surfl(id,isurf),surfl(iz,isurf), &
+                      surfl(iy,isurf),surfl(ix,isurf)) = isurf + surfstart(myid)
+          ENDDO
+       ENDIF
+!
+!--    Gather column start indices
+#if defined( __parallel )
+       CALL MPI_Allgather(surfl_col_start, nnx*nny, MPI_INTEGER,             &
+                          surfg_col_start, nnx*nny, MPI_INTEGER, comm2d, ierr)
+       IF ( ierr /= 0 ) THEN
+          WRITE(9,*) 'Error MPI_AllGather1b:', ierr, surfl_col_start, surfg_col_start
+          FLUSH(9)
+       ENDIF
+!
+!--    Convert local indices (->surfl) to global (->surf)
+       DO  i = 0, numprocs-1
+          surfg_col_start(i*nnx*nny:(i+1)*nnx*nny-1) =                      &
+                surfg_col_start(i*nnx*nny:(i+1)*nnx*nny-1) + surfstart(i)
+       ENDDO
+#else
+       surfg_col_start(0:(nx+1)*(ny+1)-1) = surfl_col_start(0:(nx+1)*(ny+1)-1)
+#endif
+       surfg_col_start((nx+1)*(ny+1)) = nsurf+1
+!
 !--    allocation of the arrays for direct and diffusion radiation
        IF ( debug_output )  CALL debug_message( 'allocation of radiation arrays', 'info' )
@@ -7483,5 +7402,4 @@
         REAL(wp), DIMENSION(:), ALLOCATABLE           :: vffrac0       !< dtto (original values)
         REAL(wp), DIMENSION(:), ALLOCATABLE           :: ztransp       !< array of transparency in z steps
-        INTEGER(iwp)                                  :: lowest_free_ray !< index into zdirs
         INTEGER(iwp), DIMENSION(:), ALLOCATABLE       :: itarget       !< face indices of detected obstacles
         INTEGER(iwp)                                  :: itarg0, itarg1
@@ -7502,6 +7420,8 @@
         INTEGER(iwp)                                  :: max_track_len !< maximum 2d track length
 #if defined( __parallel )
-        INTEGER(iwp), DIMENSION(:), ALLOCATABLE,TARGET:: nzterrl_l
-        INTEGER(iwp), DIMENSION(:,:), POINTER         :: nzterrl
+        INTEGER(iwp), DIMENSION(:), ALLOCATABLE,TARGET:: nzterrtl_l
+        INTEGER(iwp), DIMENSION(:), ALLOCATABLE,TARGET:: nzterrbl_l
+        INTEGER(iwp), DIMENSION(:,:), POINTER         :: nzterrtl
+        INTEGER(iwp), DIMENSION(:,:), POINTER         :: nzterrbl
         INTEGER(iwp)                                  :: minfo
         REAL(wp), DIMENSION(:), POINTER, SAVE         :: lad_s_rma       !< fortran 1D pointer
@@ -7540,20 +7460,32 @@
 
 !--     initialize temporary terrain and plant canopy height arrays (global 2D array!)
-        ALLOCATE( nzterr(0:(nx+1)*(ny+1)-1) )
+        ALLOCATE( nzterrt(0:(nx+1)*(ny+1)-1) )
+        ALLOCATE( nzterrb(0:(nx+1)*(ny+1)-1) )
 #if defined( __parallel )
-        !ALLOCATE( nzterrl(nys:nyn,nxl:nxr) )
-        ALLOCATE( nzterrl_l((nyn-nys+1)*(nxr-nxl+1)) )
-        nzterrl(nys:nyn,nxl:nxr) => nzterrl_l(1:(nyn-nys+1)*(nxr-nxl+1))
-        nzterrl = topo_top_ind(nys:nyn,nxl:nxr,0)
-        CALL MPI_AllGather( nzterrl_l, nnx*nny, MPI_INTEGER, &
-                            nzterr, nnx*nny, MPI_INTEGER, comm2d, ierr )
+        ALLOCATE( nzterrtl_l((nyn-nys+1)*(nxr-nxl+1)) )
+        ALLOCATE( nzterrbl_l((nyn-nys+1)*(nxr-nxl+1)) )
+        nzterrtl(nys:nyn,nxl:nxr) => nzterrtl_l(1:(nyn-nys+1)*(nxr-nxl+1))
+        nzterrbl(nys:nyn,nxl:nxr) => nzterrbl_l(1:(nyn-nys+1)*(nxr-nxl+1))
+        nzterrtl = topo_top_ind(nys:nyn,nxl:nxr,5)
+        nzterrbl = topo_top_ind(nys:nyn,nxl:nxr,0)
+        CALL MPI_AllGather( nzterrtl_l, nnx*nny, MPI_INTEGER, &
+                            nzterrt, nnx*nny, MPI_INTEGER, comm2d, ierr )
         IF ( ierr /= 0 ) THEN
-            WRITE(9,*) 'Error MPI_AllGather1:', ierr, SIZE(nzterrl_l), nnx*nny, &
-                       SIZE(nzterr), nnx*nny
+            WRITE(9,*) 'Error MPI_AllGather1t:', ierr, SIZE(nzterrtl_l), nnx*nny, &
+                       SIZE(nzterrt), nnx*nny
             FLUSH(9)
         ENDIF
-        DEALLOCATE(nzterrl_l)
+        CALL MPI_AllGather( nzterrbl_l, nnx*nny, MPI_INTEGER, &
+                            nzterrb, nnx*nny, MPI_INTEGER, comm2d, ierr )
+        IF ( ierr /= 0 ) THEN
+            WRITE(9,*) 'Error MPI_AllGather1b:', ierr, SIZE(nzterrbl_l), nnx*nny, &
+                       SIZE(nzterrb), nnx*nny
+            FLUSH(9)
+        ENDIF
+        DEALLOCATE(nzterrtl_l)
+        DEALLOCATE(nzterrbl_l)
 #else
-        nzterr = RESHAPE( topo_top_ind(nys:nyn,nxl:nxr,0), (/(nx+1)*(ny+1)/) )
+        nzterrt = RESHAPE( topo_top_ind(nys:nyn,nxl:nxr,5), (/(nx+1)*(ny+1)/) )
+        nzterrb = RESHAPE( topo_top_ind(nys:nyn,nxl:nxr,0), (/(nx+1)*(ny+1)/) )
 #endif
         IF ( plant_canopy )  THEN
@@ -7701,5 +7633,5 @@
             !--Select a proper half-sphere for 2D raytracing
             SELECT CASE ( td )
-               CASE ( iup_u, iup_l )
+               CASE ( iup )
                   az0 = 0._wp
                   naz = raytrace_discrete_azims
@@ -7708,5 +7640,12 @@
                   nzn = raytrace_discrete_elevs / 2
                   zns = pi / 2._wp / REAL(nzn, wp)
-               CASE ( isouth_u, isouth_l )
+               CASE ( idown )
+                  az0 = 0._wp
+                  naz = raytrace_discrete_azims
+                  azs = 2._wp * pi / REAL(naz, wp)
+                  zn0 = pi / 2._wp
+                  nzn = raytrace_discrete_elevs / 2
+                  zns = pi / 2._wp / REAL(nzn, wp)
+               CASE ( isouth )
                   az0 = pi / 2._wp
                   naz = raytrace_discrete_azims / 2
@@ -7715,5 +7654,5 @@
                   nzn = raytrace_discrete_elevs
                   zns = pi / REAL(nzn, wp)
-               CASE ( inorth_u, inorth_l )
+               CASE ( inorth )
                   az0 = - pi / 2._wp
                   naz = raytrace_discrete_azims / 2
@@ -7722,5 +7661,5 @@
                   nzn = raytrace_discrete_elevs
                   zns = pi / REAL(nzn, wp)
-               CASE ( iwest_u, iwest_l )
+               CASE ( iwest )
                   az0 = pi
                   naz = raytrace_discrete_azims / 2
@@ -7729,5 +7668,5 @@
                   nzn = raytrace_discrete_elevs
                   zns = pi / REAL(nzn, wp)
-               CASE ( ieast_u, ieast_l )
+               CASE ( ieast )
                   az0 = 0._wp
                   naz = raytrace_discrete_azims / 2
@@ -7744,6 +7683,5 @@
 
             ALLOCATE ( zdirs(1:nzn), zcent(1:nzn), zbdry(0:nzn), vffrac(1:nzn*naz), &
-                       ztransp(1:nzn*naz), itarget(1:nzn*naz) )   !FIXME allocate itarget only
-                                                                  !in case of rad_angular_discretization
+                       ztransp(1:nzn*naz), itarget(1:nzn*naz) )
 
             itarg0 = 1
@@ -7751,5 +7689,5 @@
             zcent(:) = (/( zn0+(REAL(izn,wp)-.5_wp)*zns, izn=1, nzn )/)
             zbdry(:) = (/( zn0+REAL(izn,wp)*zns, izn=0, nzn )/)
-            IF ( td == iup_u  .OR.  td == iup_l )  THEN
+            IF ( td == iup )  THEN
                vffrac(1:nzn) = (COS(2 * zbdry(0:nzn-1)) - COS(2 * zbdry(1:nzn))) / 2._wp / REAL(naz, wp)
 !
@@ -7759,4 +7697,10 @@
                ENDDO
 !--            sum of whole vffrac equals 1, verified
+            ELSEIF ( td == idown )  THEN
+               vffrac(1:nzn) = -(COS(2 * zbdry(0:nzn-1)) - COS(2 * zbdry(1:nzn))) / 2._wp / REAL(naz, wp)
+               DO iaz = 1, naz-1
+                  vffrac(iaz*nzn+1:(iaz+1)*nzn) = vffrac(1:nzn)
+               ENDDO
+!--            sum of whole vffrac equals 1, verified
             ENDIF
 !
@@ -7764,5 +7708,5 @@
             DO iaz = 1, naz
                azmid = az0 + (REAL(iaz, wp) - .5_wp) * azs
-               IF ( td /= iup_u  .AND.  td /= iup_l )  THEN
+               IF ( td /= iup  .AND.  td /= idown )  THEN
                   az2 = REAL(iaz, wp) * azs - pi/2._wp
                   az1 = az2 - azs
@@ -7783,25 +7727,27 @@
                                     surfstart(myid) + isurflt, facearea(td),  &
                                     vffrac(itarg0:itarg1), .TRUE., .TRUE.,    &
-                                    .FALSE., lowest_free_ray,                 &
-                                    ztransp(itarg0:itarg1),                   &
+                                    .FALSE., ztransp(itarg0:itarg1),          &
                                     itarget(itarg0:itarg1))
 
-               skyvf(isurflt) = skyvf(isurflt) + &
-                                SUM(vffrac(itarg0:itarg0+lowest_free_ray-1))
-               skyvft(isurflt) = skyvft(isurflt) + &
-                                 SUM(ztransp(itarg0:itarg0+lowest_free_ray-1) &
-                                             * vffrac(itarg0:itarg0+lowest_free_ray-1))
-
+               skyvf(isurflt) = skyvf(isurflt) +                    &
+                                SUM(vffrac(itarg0:itarg1),          &
+                                    MASK=(itarget(itarg0:itarg1)<0))
+               skyvft(isurflt) = skyvft(isurflt) +                                   &
+                                 SUM(ztransp(itarg0:itarg1) * vffrac(itarg0:itarg1), &
+                                     MASK=(itarget(itarg0:itarg1)<0))
+!
 !--            Save direct solar transparency
                j = MODULO(NINT(azmid/                                          &
                                (2._wp*pi)*raytrace_discrete_azims-.5_wp, iwp), &
                           raytrace_discrete_azims)
-
-               DO k = 1, raytrace_discrete_elevs/2
-                  i = dsidir_rev(k-1, j)
-                  IF ( i /= -1  .AND.  k <= lowest_free_ray )  &
-                     dsitrans(isurflt, i) = ztransp(itarg0+k-1)
-               ENDDO
-
+!
+!--            For down direction there is no direct irradiance, otherwise az0=0
+               IF ( td /= idown )  THEN
+                  DO  k = 1, raytrace_discrete_elevs/2
+                     i = dsidir_rev(k-1, j)
+                     IF ( i /= -1  .AND.  itarget(itarg0+k-1) < 0 )  &
+                        dsitrans(isurflt, i) = ztransp(itarg0+k-1)
+                  ENDDO
+               ENDIF
 !
 !--            Advance itarget indices
@@ -7820,5 +7766,5 @@
                itarg0 = 1
                DO WHILE ( itarg0 <= nzn*naz )
-                  IF ( itarget(itarg0) /= -1 )  EXIT
+                  IF ( itarget(itarg0) >= 0 )  EXIT
                   itarg0 = itarg0 + 1
                ENDDO
@@ -7983,5 +7929,5 @@
               CALL raytrace_2d(ta, yxdir, nzn, zdirs,                                &
                                    -999, -999._wp, vffrac, .FALSE., .FALSE., .TRUE., &
-                                   lowest_free_ray, ztransp, itarget)
+                                   ztransp, itarget)
 
 !--           Save direct solar transparency
@@ -7991,5 +7937,5 @@
               DO  k = 1, raytrace_discrete_elevs/2
                  i = dsidir_rev(k-1, j)
-                 IF ( i /= -1  .AND.  k <= lowest_free_ray ) &
+                 IF ( i /= -1  .AND.  itarget(k) < 0 ) &
                     dsitransc(ipcgb, i) = ztransp(k)
               ENDDO
@@ -8010,6 +7956,5 @@
            zns = pi / REAL(nzn, wp)
            ALLOCATE ( zdirs(1:nzn), zcent(1:nzn), zbdry(0:nzn), vffrac(1:nzn*naz), vffrac0(1:nzn), &
-                      ztransp(1:nzn*naz), itarget(1:nzn*naz) )   !FIXME allocate itarget only
-                                                                 !in case of rad_angular_discretization
+                      ztransp(1:nzn*naz), itarget(1:nzn*naz) )
 
            zcent(:) = (/( zn0+(REAL(izn,wp)-.5_wp)*zns, izn=1, nzn )/)
@@ -8059,14 +8004,14 @@
                  CALL raytrace_2d(ta, yxdir, nzn, zdirs,                         &
                                   -999, -999._wp, vffrac(itarg0:itarg1), .TRUE., &
-                                  .FALSE., .TRUE., lowest_free_ray,              &
-                                  ztransp(itarg0:itarg1),                        &
+                                  .FALSE., .TRUE., ztransp(itarg0:itarg1),       &
                                   itarget(itarg0:itarg1))
 
 !--              Sky view factors for MRT
                  mrtsky(imrt) = mrtsky(imrt) + &
-                                  SUM(vffrac(itarg0:itarg0+lowest_free_ray-1))
+                                  SUM(vffrac(itarg0:itarg1),          &
+                                      MASK=(itarget(itarg0:itarg1)<0))
                  mrtskyt(imrt) = mrtskyt(imrt) + &
-                                   SUM(ztransp(itarg0:itarg0+lowest_free_ray-1) &
-                                               * vffrac(itarg0:itarg0+lowest_free_ray-1))
+                                   SUM(ztransp(itarg0:itarg1) * vffrac(itarg0:itarg1), &
+                                       MASK=(itarget(itarg0:itarg1)<0))
 !--              Direct solar transparency for MRT
                  j = MODULO(NINT(azmid/                                         &
@@ -8075,5 +8020,5 @@
                  DO  k = 1, raytrace_discrete_elevs/2
                     i = dsidir_rev(k-1, j)
-                    IF ( i /= -1  .AND.  k <= lowest_free_ray ) &
+                    IF ( i /= -1  .AND.  itarget(itarg0+k-1) < 0 ) &
                        mrtdsit(imrt, i) = ztransp(itarg0+k-1)
                  ENDDO
@@ -8092,5 +8037,5 @@
               itarg0 = 1
               DO WHILE ( itarg0 <= nzn*naz )
-                 IF ( itarget(itarg0) /= -1 )  EXIT
+                 IF ( itarget(itarg0) >= 0 )  EXIT
                  itarg0 = itarg0 + 1
               ENDDO
@@ -8183,5 +8128,5 @@
 
 !--     deallocate temporary global arrays
-        DEALLOCATE(nzterr)
+        DEALLOCATE( nzterrt, nzterrb )
 
         IF ( plant_canopy )  THEN
@@ -8607,5 +8552,5 @@
 !--             in the array nzterr and plantt and id of the coresponding processor
                 CALL radiation_calc_global_offset( box(3), box(2), 0, 1, offs_glob=ig )
-                IF ( box(1) <= nzterr(ig) )  THEN
+                IF ( box(1) <= nzterrb(ig) )  THEN
                     visible = .FALSE.
                     RETURN
@@ -8703,5 +8648,5 @@
    SUBROUTINE raytrace_2d(origin, yxdir, nrays, zdirs, iorig, aorig, vffrac,  &
                               calc_svf, create_csf, skip_1st_pcb,             &
-                              lowest_free_ray, transparency, itarget)
+                              transparency, itarget)
       IMPLICIT NONE
 
@@ -8716,11 +8661,14 @@
       LOGICAL, INTENT(in)                    ::  create_csf    !< whether to create canopy sink factors
       LOGICAL, INTENT(in)                    ::  skip_1st_pcb  !< whether to skip first plant canopy box during raytracing
-      INTEGER(iwp), INTENT(out)              ::  lowest_free_ray !< index into zdirs
       REAL(wp), DIMENSION(nrays), INTENT(OUT) ::  transparency !< transparencies of zdirs paths
-      INTEGER(iwp), DIMENSION(nrays), INTENT(OUT) ::  itarget  !< global indices of target faces for zdirs
-
-      INTEGER(iwp), DIMENSION(nrays)         ::  target_procs
-      REAL(wp)                               ::  horizon       !< highest horizon found after raytracing (z/hdist)
+      INTEGER(iwp), DIMENSION(nrays), INTENT(OUT) ::  itarget  !< global indices of target faces for zdirs or <0 for sky
+
+      LOGICAL                                ::  is_mixed_col  !< whether current column contains full-3D geometry
+      INTEGER(iwp)                           ::  lowest_free_ray  !< index into zdirs
+      INTEGER(iwp)                           ::  lowest_mixed_ray !< index into zdirs
+      REAL(wp)                               ::  full_horizon  !< highest full horizon found after raytracing (z/hdist)
       INTEGER(iwp)                           ::  i, k, l, d
+      INTEGER(iwp)                           ::  iray         !< index into zdirs
+      INTEGER(iwp)                           ::  isurf        !< index into surf(l)
       INTEGER(iwp)                           ::  seldim       !< dimension to be incremented
       REAL(wp), DIMENSION(2)                 ::  yxorigin     !< horizontal copy of origin (y,x)
@@ -8729,6 +8677,8 @@
       REAL(wp)                               ::  nextdist     !< end of current crossing
       REAL(wp)                               ::  crmid        !< midpoint of crossing
-      REAL(wp)                               ::  horz_entry   !< horizon at entry to column
-      REAL(wp)                               ::  horz_exit    !< horizon at exit from column
+      REAL(wp)                               ::  horz_full_entry  !< full horizon at entry to column
+      REAL(wp)                               ::  horz_full_exit   !< full horizon at exit from column
+      REAL(wp)                               ::  horz_mixed_entry !< mixed horizon at entry to column
+      REAL(wp)                               ::  horz_mixed_exit  !< mixed horizon at exit from column
       REAL(wp)                               ::  bdydim       !< boundary for current dimension
       REAL(wp), DIMENSION(2)                 ::  crossdist    !< distances to boundary for dimensions
@@ -8738,5 +8688,7 @@
       INTEGER(iwp), DIMENSION(2)             ::  dimdelta     !< dimension direction = +- 1
       INTEGER(iwp)                           ::  ip           !< number of processor where gridbox reside
-      INTEGER(iwp)                           ::  ig           !< 1D index of gridbox in global 2D array
+      INTEGER(iwp)                           ::  ip_last      !< previous number of processor where gridbox reside
+      INTEGER(iwp)                           ::  ig           !< 1D index of grid column in global 2D array
+      INTEGER(iwp)                           ::  ig_last      !< 1D index of previous column in global 2D array
       INTEGER(iwp)                           ::  maxboxes     !< max no of CSF created
       INTEGER(iwp)                           ::  nly          !< maximum  plant canopy height
@@ -8746,5 +8698,5 @@
       INTEGER(iwp)                           ::  zb1
       INTEGER(iwp)                           ::  nz
-      INTEGER(iwp)                           ::  iz
+      INTEGER(iwp)                           ::  kz
       INTEGER(iwp)                           ::  zsgn
       INTEGER(iwp)                           ::  lastdir      !< wall direction before hitting this column
@@ -8755,4 +8707,7 @@
       INTEGER(iwp)                           ::  wcount       !< RMA window item count
       INTEGER(MPI_ADDRESS_KIND)              ::  wdisp        !< RMA window displacement
+      INTEGER(iwp), DIMENSION(:), ALLOCATABLE::  vert_col     !< vertical faces from previous to current column
+      INTEGER(iwp), DIMENSION(:), ALLOCATABLE::  up_col       !< upward oriented surfaces in current column
+      INTEGER(iwp), DIMENSION(:), ALLOCATABLE::  down_col     !< downward oriented surfaces in current column
 #endif
 
@@ -8769,11 +8724,15 @@
       yxorigin(:) = origin(2:3)
       transparency(:) = 1._wp !-- Pre-set the all rays to transparent before reducing
-      horizon = -HUGE(1._wp)
+      full_horizon = -HUGE(1._wp)
+      lowest_mixed_ray = nrays
       lowest_free_ray = nrays
-      IF ( rad_angular_discretization  .AND.  calc_svf )  THEN
+      IF ( rad_angular_discretization )  THEN
          ALLOCATE(target_surfl(nrays))
          target_surfl(:) = -1
          lastdir = -999
          lastcolumn(:) = -999
+         ALLOCATE( vert_col(nz_urban_b:nz_urban_t) )
+         ALLOCATE( up_col(nz_urban_b:nz_urban_t) )
+         ALLOCATE( down_col(nz_urban_b:nz_urban_t) )
       ENDIF
 
@@ -8806,4 +8765,6 @@
       ENDIF
 
+      ip_last = -1
+      ig_last = -1
       lastdist = 0._wp
 
